//+------------------------------------------------------------------+
//|                                                  Tradesignal.mq4 |
//|                                Copyright  2009, www.mywavez.net |
//|                                          http://www.mywavez.net/ |
//+------------------------------------------------------------------+

                                                                      // added breakeven, fixed sell order, extern magicnumber
extern double Lots               =    0.1;                            // minimumlots
extern double MaximumRisk        =   0.05;                            // breakeven
extern double sl                 =     80;
extern double tp                 =    600;
extern double DecreaseFactor     =      3;
extern int    MAGICMA            = 777000;

extern bool   UseBreakeven       =   true;
extern int    breakeven          =    100;
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
     //lot= 1.0;
     
//---- calculate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>2)   NormalizeDouble(lot-lot*losses/DecreaseFactor,1);      //            lot=2.0;
     
     }
//---- return lot size
   if(lot<0.01) lot=0.01;
   return(lot);
  }
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double st1;
   double st2;
   double al1;
   double al2;

   int    res;
   
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get stochasics 
   st1=iStochastic(NULL,0,21,4,4,MODE_SMA,0, MODE_MAIN,0);
   st2=iStochastic(NULL,0,21,4,4,MODE_SMA,0, MODE_MAIN,1);
    
//---- get Alligator value
   al1=iAlligator(NULL,0,13,8,8,5,5,3,MODE_SMMA,PRICE_MEDIAN,MODE_GATORJAW,1);
      
//---- Calculate stoploss
//---- double vallow=Low[iLowest(NULL,0,MODE_LOW,10,10)]
//---- double valhigh=High[iHighest(NULL,0,MODE_HIGH,10,10)];
   

//---- sell conditions
   if((Close[1] < al1) && (st2>20) && (st1<20))  
     {
      res=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,(Bid+sl*Point),(Bid-tp*Point),"",MAGICMA,0,Red);
      return;
     }
//---- buy conditions
   if((Close[1] > al1) && (st2<80) && (st1>80))  
     {
      res=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,(Ask-sl*Point),(Ask+tp*Point),"",MAGICMA,0,Blue);
      return;
     }
//----
  }
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double ma;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get Moving Average 
   ma=iMA(NULL,0,50,0,MODE_SMA,PRICE_CLOSE,0);
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(Open[1]>ma && Close[1]<ma) OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if(Open[1]<ma && Close[1]>ma) OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
         break;
        }
     }
//----
  }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else                                    CheckForClose();
//----


   if(UseBreakeven)
   {
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderSymbol() != Symbol() || OrderMagicNumber() != MAGICMA) continue;
      
      if(OrderType() == OP_BUY)
       
      if(breakeven>0)  
              {                
               if(Bid-OrderOpenPrice() > (Point*breakeven))
                 {
                  if(OrderStopLoss() != OrderOpenPrice() && OrderStopLoss() < OrderOpenPrice())
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Red);
                     //Print("Moved Buy to Breakeven");
                     return(0);
                    }
                 }
              } 
                     
      if(OrderType()==OP_SELL)

      if(breakeven>0)  
              {                 
               if((OrderOpenPrice()-Ask)> (Point*breakeven))
                 {
                  if(OrderStopLoss() != OrderOpenPrice() && OrderStopLoss() > OrderOpenPrice())
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Red);
                     //Print("Moved Sell to Breakeven");
                     return(0);
                    }
                 }
              }     
     } 
     }
     
       }



